Index: src/redisplay-output.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/redisplay-output.c,v
retrieving revision 1.14
diff -u -w -u -w -r1.14 redisplay-output.c
--- src/redisplay-output.c	2001/09/20 06:29:11	1.14
+++ src/redisplay-output.c	2001/12/13 04:56:33
@@ -1117,46 +1117,6 @@
 }
 
 /****************************************************************************
- redisplay_output_display_block
-
- Given a display line, a block number for that start line, output all
- runes between start and end in the specified display block.
- ****************************************************************************/
-static void
-redisplay_output_display_block (struct window *w, struct display_line *dl, int block,
-				int start, int end, int start_pixpos, int cursor_start,
-				int cursor_width, int cursor_height)
-{
-  struct frame *f = XFRAME (w->frame);
-  struct device *d = XDEVICE (f->device);
-  /* Temporarily disabled until generalization is done. */
-#if 0
-  struct display_block *db = Dynarr_atp (dl->display_blocks, block);
-  rune_dynarr *rba = db->runes;
-  struct rune *rb;
-  int xpos, width;
-  rb = Dynarr_atp (rba, start);
-
-  if (!rb)
-      /* Nothing to do so don't do anything. */
-      return;
-
-  xpos = max (start_pixpos, rb->xpos);
-
-  if (end < 0)
-    end = Dynarr_length (rba);
-
-  rb  = Dynarr_atp (rba, end - 1);
-  width = rb->xpos + rb->width - xpos;
-#endif
-  /* now actually output the block. */
-  DEVMETH (d, output_display_block, (w, dl, block, start,
-				     end, start_pixpos,
-				     cursor_start, cursor_width,
-				     cursor_height));
-}
-
-/****************************************************************************
  redisplay_unmap_subwindows
 
  Remove subwindows from the area in the box defined by the given
@@ -1579,6 +1539,323 @@
 				    cursor_width, cursor_height,
 				    offset_bitmap));
 }
+
+#if 1
+extern Lisp_Object Vmodeline_face;
+
+void redisplay_bevel_modeline(struct window *w, struct display_line *dl)
+{
+  struct frame *f = XFRAME (w->frame);
+  struct device *d = XDEVICE (f->device);
+  int shadow_thickness = MODELINE_SHADOW_THICKNESS (w);
+  int x,y, width, height;
+  int findex;
+
+  if (shadow_thickness == 0) return;
+
+  findex = get_builtin_face_cache_index (w, Vmodeline_face);
+
+  x = WINDOW_MODELINE_LEFT (w);
+  width = WINDOW_MODELINE_RIGHT (w) - x;
+  y = dl->ypos - dl->ascent - shadow_thickness;
+  height = dl->ascent + dl->descent + 2 * shadow_thickness;
+
+  MAYBE_DEVMETH (d, bevel_area, (w, findex,
+				 x, y, width, height, abs(shadow_thickness),
+				 EDGE_ALL,
+				 (shadow_thickness < 0) ? EDGE_BEVEL_IN : EDGE_BEVEL_OUT));
+}
+
+/****************************************************************************
+ redisplay_output_display_block
+
+ Given a display line, a block number for that start line, output all
+ runes between start and end in the specified display block.
+ ****************************************************************************/
+static void
+redisplay_output_display_block (struct window *w,
+				struct display_line *dl, int block,
+				int start, int end, int start_pixpos,
+				int cursor_start, int cursor_width,
+				int cursor_height)
+{
+  struct frame *f = XFRAME (w->frame);
+  struct device *d = XDEVICE (f->device);
+
+  if (HAS_DEVMETH_P(d, output_display_block))
+    {
+      /* Doesn't use the shared output methods! */
+      DEVMETH (d, output_display_block, (w, dl, block, start,
+					 end, start_pixpos,
+					 cursor_start, cursor_width,
+					 cursor_height));
+    }
+  else
+    {
+      /* Use the standard output device methods */
+      Emchar_dynarr *buf = Dynarr_new (Emchar);
+      Lisp_Object window;
+
+      struct display_block *db = Dynarr_atp (dl->display_blocks, block);
+      rune_dynarr *rba = db->runes;
+      struct rune *rb;
+
+      int elt = start;
+      face_index findex;
+      int xpos, width;
+      Lisp_Object charset = Qunbound; /* Qnil is a valid charset when
+					 MULE is not defined */
+
+      XSETWINDOW (window, w);
+      rb = Dynarr_atp (rba, start);
+
+      if (!rb)
+	{
+	  /* Nothing to do so don't do anything. */
+	  return;
+	}
+      else
+	{
+	  findex = rb->findex;
+	  xpos = rb->xpos;
+	  width = 0;
+	  if (rb->type == RUNE_CHAR)
+	    charset = CHAR_CHARSET (rb->object.chr.ch);
+	}
+
+      if (end < 0)
+	end = Dynarr_length (rba);
+      Dynarr_reset (buf);
+
+      while (elt < end)
+	{
+	  rb = Dynarr_atp (rba, elt);
+
+	  if (rb->findex == findex && rb->type == RUNE_CHAR
+	      && rb->object.chr.ch != '\n' && rb->cursor_type != CURSOR_ON
+	      && EQ (charset, CHAR_CHARSET (rb->object.chr.ch)))
+	    {
+	      Dynarr_add (buf, rb->object.chr.ch);
+	      width += rb->width;
+	      elt++;
+	    }
+	  else
+	    {
+	      if (Dynarr_length (buf))
+		{
+		  MAYBE_DEVMETH (d, output_string, (w, dl, buf, xpos, 0,
+						    start_pixpos, width,
+						    findex, 0, cursor_start,
+						    cursor_width,
+						    cursor_height));
+		  xpos = rb->xpos;
+		  width = 0;
+		}
+	      Dynarr_reset (buf);
+	      width = 0;
+
+	      if (rb->type == RUNE_CHAR)
+		{
+		  findex = rb->findex;
+		  xpos = rb->xpos;
+		  charset = CHAR_CHARSET (rb->object.chr.ch);
+
+		  if (rb->cursor_type == CURSOR_ON)
+		    {
+		      if (rb->object.chr.ch == '\n')
+			{
+			  MAYBE_DEVMETH (d, output_eol_cursor, (w, dl, xpos, findex));
+			}
+		      else
+			{
+			  Dynarr_add (buf, rb->object.chr.ch);
+			  MAYBE_DEVMETH (d, output_string,
+					 (w, dl, buf, xpos, 0, start_pixpos,
+					  rb->width, findex, 1,
+					  cursor_start, cursor_width,
+					  cursor_height));
+			  Dynarr_reset (buf);
+			}
+
+		      xpos += rb->width;
+		      elt++;
+		    }
+		  else if (rb->object.chr.ch == '\n')
+		    {
+		      /* Clear in case a cursor was formerly here. */
+		      redisplay_clear_region (window, findex, xpos,
+					      DISPLAY_LINE_YPOS(dl),
+					      rb->width,
+					      DISPLAY_LINE_HEIGHT(dl));
+		      elt++;
+		    }
+		}
+	      else if (rb->type == RUNE_BLANK || rb->type == RUNE_HLINE)
+		{
+		  if (rb->type == RUNE_BLANK)
+		      MAYBE_DEVMETH (d, output_blank, (w, dl, rb, start_pixpos, cursor_start,
+						       cursor_width));
+		  else
+		    {
+		      /* #### Our flagging of when we need to redraw the
+			 modeline shadows sucks.  Since RUNE_HLINE is only used
+			 by the modeline at the moment it is a good bet
+			 that if it gets redrawn then we should also
+			 redraw the shadows.  This won't be true forever.
+			 We borrow the shadow_thickness_changed flag for
+			 now. */
+		      w->shadow_thickness_changed = 1;
+		      MAYBE_DEVMETH (d, output_horizontal_line, (w, dl, rb));
+		    }
+
+		  elt++;
+		  if (elt < end)
+		    {
+		      rb = Dynarr_atp (rba, elt);
+
+		      findex = rb->findex;
+		      xpos = rb->xpos;
+		    }
+		}
+	      else if (rb->type == RUNE_DGLYPH)
+		{
+		  Lisp_Object instance;
+		  struct display_box dbox;
+		  struct display_glyph_area dga;
+		  redisplay_calculate_display_boxes (dl, rb->xpos, rb->object.dglyph.xoffset,
+						     start_pixpos, rb->width,
+						     &dbox, &dga);
+
+		  XSETWINDOW (window, w);
+		  instance = glyph_image_instance (rb->object.dglyph.glyph,
+						   window, ERROR_ME_NOT, 1);
+		  findex = rb->findex;
+
+		  if (IMAGE_INSTANCEP (instance))
+		    {
+		      switch (XIMAGE_INSTANCE_TYPE (instance))
+			{
+			case IMAGE_MONO_PIXMAP:
+			case IMAGE_COLOR_PIXMAP:
+			  redisplay_output_pixmap(w,instance,&dbox,&dga,findex,
+						  cursor_start, cursor_width,
+						  cursor_height, 0);
+			  break;
+
+			case IMAGE_WIDGET:
+			  if (EQ (XIMAGE_INSTANCE_WIDGET_TYPE (instance),
+				  Qlayout))
+			    {
+			      redisplay_output_layout (window, instance, &dbox, &dga, findex,
+						       cursor_start, cursor_width,
+						       cursor_height);
+			      break;
+			    }
+			case IMAGE_SUBWINDOW:
+			  redisplay_output_subwindow (w, instance, &dbox, &dga,
+						      findex, cursor_start,
+						      cursor_width, cursor_height);
+			  break;
+
+			case IMAGE_NOTHING:
+			  /* nothing is as nothing does */
+			  break;
+
+			case IMAGE_TEXT:
+			  {
+			    /* #### This is way losing.  See the comment in
+			       add_glyph_rune(). */
+			    Lisp_Object string =
+			      XIMAGE_INSTANCE_TEXT_STRING (instance);
+			    convert_intbyte_string_into_emchar_dynarr
+			      (XSTRING_DATA (string), XSTRING_LENGTH (string), buf);
+
+			    MAYBE_DEVMETH (d, output_string,
+					   (w, dl, buf, xpos,
+					    rb->object.dglyph.xoffset,
+					    start_pixpos, -1, findex,
+					    (rb->cursor_type == CURSOR_ON),
+					    cursor_start, cursor_width,
+					    cursor_height));
+			    Dynarr_reset (buf);
+			  }
+			  break;
+
+			case IMAGE_POINTER:
+			  abort ();
+			}
+		      IMAGE_INSTANCE_OPTIMIZE_OUTPUT
+			(XIMAGE_INSTANCE (instance)) = 0;
+		    }
+		  xpos += rb->width;
+		  elt++;
+		}
+	      else
+		abort ();
+	    }
+	}
+
+      if (Dynarr_length (buf))
+	MAYBE_DEVMETH (d, output_string,
+		       (w, dl, buf, xpos, 0, start_pixpos, width, findex,
+			0, cursor_start, cursor_width, cursor_height));
+
+      /* #### This is really conditionalized well for optimized
+	 performance. */
+      if (dl->modeline
+	  && !EQ (Qzero, w->modeline_shadow_thickness)
+	  && (f->clear
+	      || f->windows_structure_changed
+	      || w->shadow_thickness_changed))
+	{
+	  redisplay_bevel_modeline (w, dl);
+	}
+
+      Dynarr_free (buf);
+    }
+}
+#else
+/****************************************************************************
+ redisplay_output_display_block
+
+ Given a display line, a block number for that start line, output all
+ runes between start and end in the specified display block.
+ ****************************************************************************/
+static void
+redisplay_output_display_block (struct window *w, struct display_line *dl, int block,
+				int start, int end, int start_pixpos, int cursor_start,
+				int cursor_width, int cursor_height)
+{
+  struct frame *f = XFRAME (w->frame);
+  struct device *d = XDEVICE (f->device);
+  /* Temporarily disabled until generalization is done. */
+#if 0
+  struct display_block *db = Dynarr_atp (dl->display_blocks, block);
+  rune_dynarr *rba = db->runes;
+  struct rune *rb;
+  int xpos, width;
+  rb = Dynarr_atp (rba, start);
+
+  if (!rb)
+      /* Nothing to do so don't do anything. */
+      return;
+
+  xpos = max (start_pixpos, rb->xpos);
+
+  if (end < 0)
+    end = Dynarr_length (rba);
+
+  rb  = Dynarr_atp (rba, end - 1);
+  width = rb->xpos + rb->width - xpos;
+#endif
+  /* now actually output the block. */
+  DEVMETH (d, output_display_block, (w, dl, block, start,
+				     end, start_pixpos,
+				     cursor_start, cursor_width,
+				     cursor_height));
+}
+#endif /* 0 */
+
 
 /****************************************************************************
  redisplay_clear_region
Index: src/redisplay-x.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/redisplay-x.c,v
retrieving revision 1.27
diff -u -w -u -w -r1.27 redisplay-x.c
--- src/redisplay-x.c	2001/09/18 05:04:40	1.27
+++ src/redisplay-x.c	2001/12/13 04:56:34
@@ -62,7 +62,8 @@
 static void x_output_blank (struct window *w, struct display_line *dl,
 			    struct rune *rb, int start_pixpos,
 			    int cursor_start, int cursor_width);
-static void x_output_hline (struct window *w, struct display_line *dl,
+static void x_output_horizontal_line (struct window *w,
+				      struct display_line *dl,
 			    struct rune *rb);
 static void x_redraw_exposed_window (struct window *w, int x, int y,
 				     int width, int height);
@@ -307,211 +308,6 @@
 }
 
 /*****************************************************************************
- x_output_display_block
-
- Given a display line, a block number for that start line, output all
- runes between start and end in the specified display block.
- ****************************************************************************/
-static void
-x_output_display_block (struct window *w, struct display_line *dl, int block,
-			int start, int end, int start_pixpos, int cursor_start,
-			int cursor_width, int cursor_height)
-{
-  struct frame *f = XFRAME (w->frame);
-  Emchar_dynarr *buf = Dynarr_new (Emchar);
-  Lisp_Object window;
-
-  struct display_block *db = Dynarr_atp (dl->display_blocks, block);
-  rune_dynarr *rba = db->runes;
-  struct rune *rb;
-
-  int elt = start;
-  face_index findex;
-  int xpos, width = 0;
-  Lisp_Object charset = Qunbound; /* Qnil is a valid charset when
-				     MULE is not defined */
-
-  XSETWINDOW (window, w);
-  rb = Dynarr_atp (rba, start);
-
-  if (!rb)
-    /* Nothing to do so don't do anything. */
-    return;
-
-  findex = rb->findex;
-  xpos = rb->xpos;
-  if (rb->type == RUNE_CHAR)
-    charset = CHAR_CHARSET (rb->object.chr.ch);
-
-  if (end < 0)
-    end = Dynarr_length (rba);
-  Dynarr_reset (buf);
-
-  while (elt < end)
-    {
-      rb = Dynarr_atp (rba, elt);
-
-      if (rb->findex == findex && rb->type == RUNE_CHAR
-	  && rb->object.chr.ch != '\n' && rb->cursor_type != CURSOR_ON
-	  && EQ (charset, CHAR_CHARSET (rb->object.chr.ch)))
-	{
-	  Dynarr_add (buf, rb->object.chr.ch);
-	  width += rb->width;
-	  elt++;
-	}
-      else
-	{
-	  if (Dynarr_length (buf))
-	    {
-	      x_output_string (w, dl, buf, xpos, 0, start_pixpos, width,
-			       findex, 0, cursor_start, cursor_width,
-			       cursor_height);
-	      xpos = rb->xpos;
-	      width = 0;
-	    }
-	  Dynarr_reset (buf);
-	  width = 0;
-
-	  if (rb->type == RUNE_CHAR)
-	    {
-	      findex = rb->findex;
-	      xpos = rb->xpos;
-	      charset = CHAR_CHARSET (rb->object.chr.ch);
-
-	      if (rb->cursor_type == CURSOR_ON)
-		{
-		  if (rb->object.chr.ch == '\n')
-		    {
-		      x_output_eol_cursor (w, dl, xpos, findex);
-		    }
-		  else
-		    {
-		      Dynarr_add (buf, rb->object.chr.ch);
-		      x_output_string (w, dl, buf, xpos, 0, start_pixpos,
-				       rb->width, findex, 1,
-				       cursor_start, cursor_width,
-				       cursor_height);
-		      Dynarr_reset (buf);
-		    }
-
-		  xpos += rb->width;
-		  elt++;
-		}
-	      else if (rb->object.chr.ch == '\n')
-		{
-		  /* Clear in case a cursor was formerly here. */
-		  redisplay_clear_region (window, findex, xpos,
-					  DISPLAY_LINE_YPOS (dl),
-					  rb->width,
-					  DISPLAY_LINE_HEIGHT (dl));
-		  elt++;
-		}
-	    }
-	  else if (rb->type == RUNE_BLANK || rb->type == RUNE_HLINE)
-	    {
-	      if (rb->type == RUNE_BLANK)
-		x_output_blank (w, dl, rb, start_pixpos, cursor_start,
-				cursor_width);
-	      else
-		{
-		  /* #### Our flagging of when we need to redraw the
-                     modeline shadows sucks.  Since RUNE_HLINE is only used
-                     by the modeline at the moment it is a good bet
-                     that if it gets redrawn then we should also
-                     redraw the shadows.  This won't be true forever.
-                     We borrow the shadow_thickness_changed flag for
-                     now. */
-		  w->shadow_thickness_changed = 1;
-		  x_output_hline (w, dl, rb);
-		}
-
-	      elt++;
-	      if (elt < end)
-		{
-		  rb = Dynarr_atp (rba, elt);
-
-		  findex = rb->findex;
-		  xpos = rb->xpos;
-		}
-	    }
-	  else if (rb->type == RUNE_DGLYPH)
-	    {
-	      Lisp_Object instance;
-	      struct display_box dbox;
-	      struct display_glyph_area dga;
-	      redisplay_calculate_display_boxes (dl, rb->xpos, rb->object.dglyph.xoffset,
-						 start_pixpos, rb->width,
-						 &dbox, &dga);
-
-	      XSETWINDOW (window, w);
-	      instance = glyph_image_instance (rb->object.dglyph.glyph,
-					       window, ERROR_ME_NOT, 1);
-	      findex = rb->findex;
-
-	      if (IMAGE_INSTANCEP (instance))
-		{
-		  switch (XIMAGE_INSTANCE_TYPE (instance))
-		    {
-		    case IMAGE_MONO_PIXMAP:
-		    case IMAGE_COLOR_PIXMAP:
-		      redisplay_output_pixmap (w, instance, &dbox, &dga, findex,
-					       cursor_start, cursor_width,
-					       cursor_height, 0);
-		      break;
-
-		    case IMAGE_WIDGET:
-		      if (EQ (XIMAGE_INSTANCE_WIDGET_TYPE (instance),
-			      Qlayout))
-			{
-			  redisplay_output_layout (window, instance, &dbox, &dga, findex,
-						   cursor_start, cursor_width,
-						   cursor_height);
-			  break;
-			}
-		    case IMAGE_SUBWINDOW:
-		      redisplay_output_subwindow (w, instance, &dbox, &dga, findex,
-						  cursor_start, cursor_width,
-						  cursor_height);
-		      break;
-
-		    case IMAGE_NOTHING:
-		      /* nothing is as nothing does */
-		      break;
-
-		    case IMAGE_TEXT:
-		    case IMAGE_POINTER:
-		    default:
-		      abort ();
-		    }
-		  IMAGE_INSTANCE_OPTIMIZE_OUTPUT
-		    (XIMAGE_INSTANCE (instance)) = 0;
-		}
-
-	      xpos += rb->width;
-	      elt++;
-	    }
-	  else
-	    abort ();
-	}
-    }
-
-  if (Dynarr_length (buf))
-    x_output_string (w, dl, buf, xpos, 0, start_pixpos, width, findex,
-		     0, cursor_start, cursor_width, cursor_height);
-
-  /* #### This is really conditionalized well for optimized
-     performance. */
-  if (dl->modeline
-      && !EQ (Qzero, w->modeline_shadow_thickness)
-      && (f->clear
-	  || f->windows_structure_changed
-	  || w->shadow_thickness_changed))
-    bevel_modeline (w, dl);
-
-  Dynarr_free (buf);
-}
-
-/*****************************************************************************
  x_bevel_area
 
  Draw shadows for the given area in the given face.
@@ -1469,12 +1265,12 @@
 }
 
 /*****************************************************************************
- x_output_hline
+ x_output_horizontal_line
 
  Output a horizontal line in the foreground of its face.
  ****************************************************************************/
 static void
-x_output_hline (struct window *w, struct display_line *dl, struct rune *rb)
+x_output_horizontal_line (struct window *w, struct display_line *dl, struct rune *rb)
 {
   struct frame *f = XFRAME (w->frame);
   struct device *d = XDEVICE (f->device);
@@ -2101,7 +1897,6 @@
 {
   /* redisplay methods */
   CONSOLE_HAS_METHOD (x, text_width);
-  CONSOLE_HAS_METHOD (x, output_display_block);
   CONSOLE_HAS_METHOD (x, divider_height);
   CONSOLE_HAS_METHOD (x, eol_cursor_width);
   CONSOLE_HAS_METHOD (x, output_vertical_divider);
@@ -2114,4 +1909,8 @@
   CONSOLE_HAS_METHOD (x, bevel_area);
   CONSOLE_HAS_METHOD (x, output_string);
   CONSOLE_HAS_METHOD (x, output_pixmap);
+  CONSOLE_HAS_METHOD (x, output_eol_cursor);
+  CONSOLE_HAS_METHOD (x, output_horizontal_line);
+  CONSOLE_HAS_METHOD (x, output_vertical_divider);
+  CONSOLE_HAS_METHOD (x, output_blank);
 }
Index: src/select-gtk.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/select-gtk.c,v
retrieving revision 1.5
diff -u -w -u -w -r1.5 select-gtk.c
--- src/select-gtk.c	2001/09/20 06:29:13	1.5
+++ src/select-gtk.c	2001/12/13 04:56:34
@@ -366,7 +366,7 @@
 
 static Lisp_Object
 gtk_own_selection (Lisp_Object selection_name, Lisp_Object selection_value,
-		   Lisp_Object how_to_add, Lisp_Object selection_type)
+		   Lisp_Object how_to_add, Lisp_Object selection_type, int owned_p)
 {
   struct device *d = decode_gtk_device (Qnil);
   GtkWidget *selecting_window = GTK_WIDGET (DEVICE_GTK_APP_SHELL (d));
Index: src/toolbar-gtk.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/toolbar-gtk.c,v
retrieving revision 1.3
diff -u -w -u -w -r1.3 toolbar-gtk.c
--- src/toolbar-gtk.c	2001/09/20 06:29:16	1.3
+++ src/toolbar-gtk.c	2001/12/13 04:56:34
@@ -204,8 +204,8 @@
 	    }
 
 	  gtk_output_gdk_pixmap (f, XIMAGE_INSTANCE (instance), tb->x + x_offset,
-				 tb->y + y_offset, 0, 0, 0, 0, width, height,
-				 0, 0, 0, background_gc);
+				 tb->y + y_offset, 0, 0, width, height,
+				 0, 0, background_gc);
 	}
       else if (IMAGE_INSTANCE_TYPE (p) == IMAGE_TEXT)
 	{
